/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"

#include <webpage.h>


//############################################################################
//
void httpd (char* buffer,int *bufferlen)
//############################################################################
{	
	//Verwaltung Stackpointer
	int a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack (buffer,bufferlen,&a)==1)
		{
		return;//keine Daten fr Anwendung
		}
	
	char x = 0;
	char *Command = &x;
	
	//berprft HTTP Header 
	if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && TCP_Socket_Status[a] == 1)
		{
		unsigned char Header = 1;
		//Errechnet startpunkt der Daten im Tcp buffer
		//IP Headerlnge + TCP Headerlnge + Ethernetframe
		unsigned int result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + 
								  ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
			
		//Pointerold auf INDEX.HTM
		pointerold = Page1;
		Header = 1;
	
		Command = strstr(&buffer[result16],"webserver.jpg");
		if (Command != 0)
			{
			pointerold = webserver_jpg;
			}
			
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);	
	
		//Setzen des Ack Flags und PSH Flags	
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;
		//erzeugt HTTP OK Packet
		if (Header == 1)
			{
			tcp_add_data (HTTP_OK1,buffer,bufferlen);	
			}
		if (Header == 2)
			{
			tcp_add_data (HTTP_OK2,buffer,bufferlen);	
			}	
		//Erzeugt ein TCP Packet 
		tcp_make(buffer);			
		//Sendet das erzeugte TCP Packet 
		Write_Ethernet_Frame (buffer,*bufferlen);
		//(Ethernet Farne war aber voll) Weiters Frame mu gesendet werden!
		TCP_Socket_Status[a] = 2;
		TCP_Socket_Pointer[a] = pointerold;
		return;
		}
	
	//Senden der Webseite bzw. Daten war noch nicht Fertig (Ethernet Farne war aber voll)	
	if (TCP_Socket_Status[a] == 2) 
		{
			//Setzen des Ack Flags und PSH Flags	
			buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;
			//Speichert Sequenzcounter und Aknowledgecounter
			tcp_store(buffer);		
			//erzeugt Seiten Packet
			pointerold = TCP_Socket_Pointer[a];
			tcp_add_data (pointerold,buffer,bufferlen);
			TCP_Socket_Pointer[a] = pointerold;
			//Erzeugt ein TCP Packet 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP Packet 
			Write_Ethernet_Frame (buffer,*bufferlen);	
			if (Sendpage == 0)
				{
				TCP_Socket_Status[a] = 3;
				}
			return;		
		}
return;
}


